layui.define(['jquery', 'formUtils', 'formField'], function (exports) {
    var $ = layui.jquery;
    var utils = layui.formUtils;
    var formField = layui.formField;

    var HTML_ARRAY = [
        '<div id="{0}Box" class="layui-form-item {2}"  data-id="{0}" data-tag="{1}" data-index="{3}">',
        '   <label class="layui-form-label {0}" style="width: {3}px"><span style="color:red;">{2}</span>{1}:</label>',
        '   <div id="{1}Block" class="layui-input-block" style="margin-left: {0}px">',
        '       <input type="password" name="{0}" placeholder="{3}" value="{1}" autocomplete="off" style="width:{2}" {4}  {5} {6} class="layui-input{7}">',
        '   </div>',
        '</div>'
    ]

    var password = {
        /**
         * 根据json对象生成html对象
         * @param {object} json
         * @param {boolean} selected true 表示选择当前
         * */
        render: function (json, selected) {
            if (selected === undefined) {
                selected = false;
            }
            var _disabled = json.disabled ? 'disabled=""' : '';
            var _readonly = json.readonly ? 'readonly=""' : '';
            var _required = json.required ? 'lay-verify="required"' : '';
            var _disabledClass = json.disabled ? ' layui-disabled' : '';
            var _html = HTML_ARRAY[0].format(json.id, json.tag, selected ? 'active' : '', json.index);
            _html += HTML_ARRAY[1].format(json.required ? 'layui-form-required' : '', json.label, json.required ? '*' : '', json.labelWidth);
            _html += HTML_ARRAY[2].format(json.labelWidth, json.id);
            _html += HTML_ARRAY[3].format(json.id, json.defaultValue ? json.defaultValue : '', json.width, json.placeholder, _readonly, _disabled, _required, _disabledClass);
            _html += HTML_ARRAY[4];
            _html += HTML_ARRAY[4];
            return _html;
        },
        update: function (json) {
            var _disabled = json.disabled ? 'disabled=""' : '';
            var _readonly = json.readonly ? 'readonly=""' : '';
            var _required = json.required ? 'lay-verify="required"' : '';
            var _disabledClass = json.disabled ? ' layui-disabled' : '';
            var $block = $('#' + json.id + 'Box .layui-input-block');
            var $label = $('#' + json.id + 'Box .layui-form-label');
            $block.empty();
            $label.empty();
            $block.css("margin-left", json.labelWidth);
            $label.css("width", json.labelWidth);
            if (json.required) {
                $label.append('<span style="color:red;">*</span>');
            }
            $label.append(json.label + ":");
            var _html = '';
            //重绘设计区改id下的所有元素
            _html += HTML_ARRAY[3].format(json.id, json.defaultValue ? json.defaultValue : '', json.width, json.placeholder, _readonly, _disabled, _required, _disabledClass);
            $block.append(_html);
        },
        /* 获取对象 */
        jsonData: function (id, index, columncount) {
            //分配一个新的ID
            var _json = JSON.parse(JSON.stringify(formField.password));
            _json.id = id == undefined ? utils.guid() : id;
            _json.index = index;
            return _json;
        },
        /* 根据 json 对象显示对应的属性 */
        property: function (json) {
            $('#columnProperty').empty();
            var _html = '';
            _html = utils.renderCommonProperty(json); //获取通用属性HTML字符串
            //处理特殊字符串
            for (var key in json) {
                if (key === 'index') {
                    continue;
                }
            }
            $('#columnProperty').append(_html);
        }
    }

    exports('password', password);
});